<script>

import Tasks from '../components/Tasks.vue'
import AddTask from '../components/AddTask.vue'
import Button from '../components/Button.vue';

  export default{
    name: 'Home',
    data(){
      return {
        tasks: [],
        formToggle: false,
      }
    },
    components: {
      Tasks,
      AddTask,
      Button
    },
    methods: {

      async deleteTask(task_id){

      const response = await fetch(`api/tasks/${task_id}`, {
        method: 'DELETE',
        headers: {
          'Content-type': 'application/json'
        },
      })
      if(response.status!==200){
        alert("Can't delete the given task")
        return 
      }

      const res = await response.json()

        this.tasks = [
          ...this.tasks.filter(task => task.id!=res.id)
        ]
      },
      async addTask(new_task){

        const response = await fetch('api/tasks', {
          method: 'POST',
          headers: {
            'Content-type': 'application/json',
          },
          body: JSON.stringify(new_task)
        })
        // console.log(response)
        const data = await response.json();
        this.tasks=[
          ...this.tasks, data
        ]
      },
      async fetchTasks(){
        const response = await fetch('api/tasks')

        const res= await response.json();

        return res;
      },

      async fetchTask(task_id){
        const response = await fetch(`api/tasks/${task_id}`)

        const res = await response.json();

        return res;
      },
      
      changeToggle(formToggleStatus) {
        this.formToggle = formToggleStatus;
      },


      async toggleTask(task_id){

      const currentTask = await this.fetchTask(task_id)

      const updatedTask = {...currentTask , state: !currentTask.state};

      const response = await fetch(`api/tasks/${task_id}`,{
          method: 'PUT',
          headers: {
            'Content-type': 'application/json'
          },
          body: JSON.stringify(updatedTask)
        }
      )

      this.tasks = [
        ...this.tasks.map(task=> {
          if(task.id == task_id){
            return {...task , state: !task.state}
          }
          return task
        })
      ]

      },
    },



      async created(){
      this.tasks = await this.fetchTasks()


      },
      computed: {
        changeStyleComponent(){
            return {
                backgroundColor: ((this.formToggle ? 'red' : 'green'))
            }
        }
      } 
    }
  
</script>

<template>
  <div>
    <div class="header_container">
        <Button
          :text="formToggle ? 'Close' : 'Add Task'"
          :formToggle="formToggle"
          @change-toggle="changeToggle"

          :style="changeStyleComponent"
        />
        <div v-show="formToggle" class="form_container">
          <AddTask @add-task="addTask"  />
        </div>
      </div>

    <Tasks  @delete-task="deleteTask" @toggle-checkbox="toggleTask" :tasks="tasks"/>
    <router-link to="/about">And I don't play cause I'm from Chicago</router-link>
    
  </div>
</template>
